#include <dll_ifc.h>
#include <string.h>
#include <stdio.h>

// TH: 28.04.2016
//define NO_GHS_DLL_DEBUGGING for 'cleaner' dll projects (oss)
#ifndef NO_GHS_DLL_DEBUGGING

#include "../boot_elf.cpp"

static void boot1()
{
#ifndef VCS_PHYS_RAM_BASE
# ifdef __CortexA9
#  define VCS_PHYS_RAM_BASE 0
# else
#  define VCS_PHYS_RAM_BASE 0xc0000000
# endif
#endif

	// TH: we load our app (elf file) via debugger (see .mbs file)
	char *app_bin = (char *)VCS_PHYS_RAM_BASE + 0x03000000;

	LoadBoot1((char *)app_bin,0x1000000);
}  

static void* my_memcpy1(void *d, const void *s, size_t n)
{
	char *dd = (char *)d;
	char *ss = (char *)s;

	while(n--)
	{
		*dd++=*ss++;
	}
	
	return d;
}
#endif // NO_GHS_DLL_DEBUGGING


extern "C"
void dll_entry()
{
#ifndef NO_GHS_DLL_DEBUGGING	
	// if dll is used directly use own memcpy
	my_memcpy=&my_memcpy1;
	
	// TH: start the 2nd bootloader
	boot1();
#endif

	// TH: force C_Dll::Get to be linked
	unsigned IfcVersion=0;

	C_Dll::Get(IfcVersion);
}

int main;

// TH: 11.10.2007 don't allow these unused codefragments as unresolveds ...
int __gh_float_printf;
int __gh_float_scanf;

//////////////////////////////////////////////////////////////////////////////////////

class C_ForceCDtor
{
	public:
	C_ForceCDtor() {}
	virtual ~C_ForceCDtor() {}
};

C_ForceCDtor g_ForceCDtor;

//////////////////////////////////////////////////////////////////////////////////////



extern "C"
{

typedef const char rodata_ptr[];
typedef int ptrdiff_t;

typedef void (*vfpt)();
extern vfpt _ctors[], _dtors[];

typedef struct node_type {
    struct node_type *next;
    void	*object;
    vfpt	routine;
} node_type;

C_Dll::C_Dll()
{

}

C_Dll::~C_Dll()
{
/*
	// call global destructors
	int i=0;

	while (_dtors[i])
	{
		STD_PRINT1(STDTERM,"C_Dll::~C_Dll call dtor %p\n",_dtors[i]);

		(*_dtors[i++])();
	}
*/
}

C_Exe::C_Exe() : C_Dll()
{
	m_magic = EXE_MAGIC;
}

C_Exe::~C_Exe()
{
	
}

//extern "C" void test_function();

bool C_Dll::Init()
{

/*----------------------------------------------------------------------*/
/*									*/
/*	Clear BSS							*/
/*									*/
/*----------------------------------------------------------------------*/
#pragma ghs rodata
	extern rodata_ptr __ghsbinfo_clear;
#pragma ghs rodata
	extern rodata_ptr __ghseinfo_clear;

	void **b = (void **) ((char *)__ghsbinfo_clear);
	void **e = (void **) ((char *)__ghseinfo_clear);

	while (b != e)
	{
		void *		t;			/* target pointer	*/
		ptrdiff_t	v;			/* value to set		*/
		size_t		n;			/* set n bytes		*/
		t = (char *)(*b++);
		v = *((ptrdiff_t *) b); b++;
		n = *((size_t    *) b); b++;

		//STD_PRINT3(STDTERM,"C_Dll::Init memset at 0x%8.8x val 0x%2.2x byt %3d\n",t,v,n);

		memset(t, v, n);
	}

//    atexit(__call_dtors);
	int i=0;

	while (_ctors[i])
	{
		//STD_PRINT1(STDTERM,"C_Dll::Init call ctor %p\n",_ctors[i]);

		(*_ctors[i++])();
	}

   return true;
}

} // extern "C"

void __call_dtors() {}
extern "C" void __record_needed_destruction(node_type node) { }


/////////////////////////////////////////////////////////////////////////////////////



