#include "dll_zbar.h"
#include "./../zbar/ZBarcode.h"
#include "./../zbar/ZBarAdapter.h"
#include "./../dll_ifc/dll_sys_access_wrap.h"


/////////////////////////////////////////////////////////////////////////////////


// this is the entry function called by the application loading the dll
// don't change name etc.
DLL_EXPORT C_Dll* C_Dll::Get(unsigned &IfcVersion)
{
	IfcVersion = DLL_IFC_VERSION;
	return new C_Dll_ZBar;
}

C_Dll_ZBar::C_Dll_ZBar()
{
}

C_Dll_ZBar::~C_Dll_ZBar()
{
}

char* C_Dll_ZBar::Name()
{
	return "zbar";
}

C_Dll::t_version C_Dll_ZBar::Version()
{
	t_version v = {ZBAR_DLL_MAJOR, 0, 0, 0};
	return v;
}

C_ZBarIfc* C_Dll_ZBar::New_ZBar(void* handle, UInt32 maxPicBufferSize)
{
	C_ZBar* pZbar = new C_ZBar(handle);
	if(pZbar)
	{
		if(!pZbar->Create(maxPicBufferSize))
		{
			delete pZbar;
			pZbar = NULL;
		}
	}
	
	return pZbar;
}

bool C_Dll_ZBar::SetSystemAccess(C_DllSystemAccess &SystemAccess)
{
	return ::SetSystemAccess(SystemAccess);
}

bool C_Dll_ZBar::SetMemoryAccess(C_MemoryAccessIfc &MemoryAccess)
{
	g_ZBarMemory = &MemoryAccess;
	return true;
}
