#ifndef __ZBAR_IFC_H__
#define __ZBAR_IFC_H__

#include "vcsIntTypes.h"


class C_ZBarResultCallbackIfc
{
public:
	virtual ~C_ZBarResultCallbackIfc() {};

	virtual bool setQRInfo(int qrcount, const unsigned char* ResultBuffer, int ResultBufferSize) = 0;
};


class C_MemoryAccessIfc;


class C_ZBarIfc
{
public:
	virtual ~C_ZBarIfc() {};
	
	static bool Init(C_MemoryAccessIfc &MemoryAccess);
	static C_ZBarIfc *New(void* handle, UInt32 maxPicBufferSize);

	virtual unsigned char* getPicBuffer(UInt32 picBufferSize) = 0;
	virtual int scanImage(unsigned char* Source, long Width, long Height) = 0;
	
	virtual bool setCallback(C_ZBarResultCallbackIfc* ptr) = 0;
	virtual C_ZBarResultCallbackIfc* getCallback() = 0;

	virtual bool resetMemory() = 0;
};


class C_MemoryListIfc
{
public:
	virtual ~C_MemoryListIfc() {};

	virtual bool Create(unsigned char* ptr = 0, UInt32 size = 0) = 0;
};


enum eZBarMode
{
	ZBAR_MODE_TESTFILE,
	ZBAR_MODE_VIDEO
};


struct sZBarThreadConfig
{
	eZBarMode Mode;
	UInt32 duration_sec;
	UInt8  cam;
	C_ZBarResultCallbackIfc* pResultCb;
};


class C_ZBarThreadManagerIfc
{
public:
	virtual ~C_ZBarThreadManagerIfc() {}

	virtual bool Create() = 0;

	virtual bool runThread(sZBarThreadConfig& zconfig) = 0;
};


#endif
