#ifndef ZBARCODE_H_INCLUDED
#define ZBARCODE_H_INCLUDED

#include <zbar_ifc.h>
#include "zbar.h"
#include "ZBarAdapter.h"



class C_ZBar: public C_ZBarIfc
{
public:
	//VCS_DEBUG_MALLOC_OPERATORS

	C_ZBar(void* handle);
	virtual ~C_ZBar();
	
	virtual bool Create(UInt32 maxPicBufferSize);

	virtual unsigned char* getPicBuffer(UInt32 picBufferSize);
	virtual int scanImage(unsigned char* Source, long Width, long Height);

	virtual bool setCallback(C_ZBarResultCallbackIfc* ptr) { m_Callback = ptr; return true; }
	virtual C_ZBarResultCallbackIfc* getCallback() { return m_Callback; }

	virtual bool resetMemory();

private:
	C_ZBarResultCallbackIfc*	m_Callback;
	void*						m_handle;

	enum {
		CALCULATOR_BUFFER_SIZE = 4000000		// remember at Static Memory Reservation in case of changing this value!
	};
};


#endif

